
#include "tools.h"

// UARTF
// SD SPID

//*****************************************************************************************************************
int main(void){

// 32Mhz (Quarz) 

system_clocks_init();																		
//-----------------------------------------------------------------------------
   
	sei();

	PMIC.CTRL |= PMIC_HILVLEN_bm; 
	PMIC.CTRL |= PMIC_MEDLVLEN_bm;
	PMIC.CTRL |= PMIC_LOLVLEN_bm;
	// Interupt einschalten
         					// Initialize Send and Receive buffers
	xfunc_out = (void (*)(char))uartSendByte; 	// Xprintf(..) mit Ausgabe (USRTF0) verbinden
 
 	uartInit(); // USARTF0 !!!!!

 
	xprintf(PSTR(" SD-Card Test ")); //Testausgabe

	while ( mmc_init() !=0) //ist der Rckgabewert ungleich NULL ist ein Fehler aufgetreten
		{
		xprintf(PSTR("** Keine MMC/SD Karte gefunden!! **\n"));	
		}
	xprintf(PSTR("Karte gefunden!!\n"));
	
	fat_init();//laden Cluster OFFSET und Size
	//Initialisierung der MMC/SD-Karte ENDE!

	unsigned char Buffer[512];
	unsigned int tmp;
	
	mmc_read_csd (Buffer);
	
	for (tmp = 0;tmp<16;tmp++)
		{
		xprintf(PSTR("%x "),Buffer[tmp]);
		};


	//Ausgabe des Root Directory
	unsigned int Clustervar;
	unsigned char Dir_Attrib = 0;
	unsigned long Size = 0;
	xprintf(PSTR("\r\nDirectory\r\n"));
	for (char a = 1;a < 240;a++)
	{
		Clustervar = fat_read_dir_ent(0,a,&Size,&Dir_Attrib,Buffer);
			if (Clustervar == 0xffff)
			{
				break;
			}
		tmp = (Size & 0x0000FFFF);
		xprintf(PSTR("Cluster = %x DirA = %x FileName = "),Clustervar,Dir_Attrib);
		xprintf(PSTR("%s"),Buffer);
		xprintf(PSTR("\r\n"));
	}
	xprintf(PSTR("\r\nDirectory Ende\r\n"));

	//Lade Cluster fr das index.htm File in den Speicher 
	Clustervar = 0;//suche im Root Verzeichnis
	if (fat_search_file((unsigned char *)"test1.txt",&Clustervar,&Size,&Dir_Attrib,Buffer) == 1)
		{
		xprintf(PSTR("\nFile Found!!\r\n"));
		//Lese File und gibt es auf der seriellen Schnittstelle aus
		for (int b = 0;b<52;b++)
			{
			fat_read_file (Clustervar,Buffer,b);
			for (int a = 0;a<512;a++)
				{
				xprintf(PSTR("%c"),Buffer[a]);
				}
			
			}
		}

	xprintf(PSTR("FERTIG!!\r\n")); // wird nicht erreicht !! irgendwo in der obigen  for Schleife ein Fehler
	  			
while(true) {


}
	
	

return 0;
}

void system_clocks_init(void)
{
unsigned char n,s;

// Save interrupts enabled/disabled state
s=SREG;
// Disable interrupts
cli();

// External 16000,000 kHz oscillator initialization
OSC.XOSCCTRL=OSC_FRQRANGE_12TO16_gc | OSC_XOSCSEL_XTAL_16KCLK_gc;
// Enable the external oscillator
OSC.CTRL|=OSC_XOSCEN_bm;

// Wait for the external oscillator to stabilize
while ((OSC.STATUS & OSC_XOSCRDY_bm)==0);

// PLL initialization
// PLL clock cource: External Osc. or Clock
// PLL multiplication factor: 2
// PLL frequency: 32,000000 MHz
// Set the PLL clock source and multiplication factor
n=(OSC.PLLCTRL & (~(OSC_PLLSRC_gm | OSC_PLLFAC_gm))) |
	OSC_PLLSRC_XOSC_gc | 2;
CCP=CCP_IOREG_gc;
OSC.PLLCTRL=n;
// Enable the PLL
OSC.CTRL|=OSC_PLLEN_bm;

// System clock prescaler A division factor: 1
// System clock prescalers B & C division factors: B:1, C:1
// ClkPer4: 32000,000 kHz
// ClkPer2: 32000,000 kHz
// ClkPer:  32000,000 kHz
// ClkCPU:  32000,000 kHz
n=(CLK.PSCTRL & (~(CLK_PSADIV_gm | CLK_PSBCDIV1_bm | CLK_PSBCDIV0_bm))) |
	CLK_PSADIV_1_gc | CLK_PSBCDIV_1_1_gc;
CCP=CCP_IOREG_gc;
CLK.PSCTRL=n;

// Wait for the PLL to stabilize
while ((OSC.STATUS & OSC_PLLRDY_bm)==0);

// Select the system clock source: Phase Locked Loop
n=(CLK.CTRL & (~CLK_SCLKSEL_gm)) | CLK_SCLKSEL_PLL_gc;
CCP=CCP_IOREG_gc;
CLK.CTRL=n;

// Disable the unused oscillators: 2 MHz, 32 MHz, internal 32 kHz
OSC.CTRL&= ~(OSC_RC2MEN_bm | OSC_RC32MEN_bm | OSC_RC32KEN_bm);

// Peripheral Clock output: Disabled
PORTCFG.CLKEVOUT=(PORTCFG.CLKEVOUT & (~PORTCFG_CLKOUT_gm)) | PORTCFG_CLKOUT_OFF_gc;

// Restore interrupts enabled/disabled state
SREG=s;


}

int uart_putchar(char c, FILE *stream) // Ausgabe PRINTF Stream init
{
   	if (c == '\n') uart_putchar('\r', stream);

	uartSendByte(c);
   	return 0;
}


