//
// This code is distributed under the GNU Public License
//		which can be found at http://www.gnu.org/licenses/gpl.txt
//
//*****************************************************************************

#include <avr/io.h>
#include <avr/interrupt.h>
#include <avr/pgmspace.h>


#include "xitoa.h"
#include "vt100.h"

// Program ROM constants

// Global variables

// Functions
void vt100Init(void)
{
	// initializes terminal to "power-on" settings
	// ESC c
	xprintf(PSTR("\x1B\x63"));
}

void vt100ClearScreen(void)
{
	// ESC [ 2 J
	xprintf(PSTR("\x1B[2J"));
}

void vt100SetAttr(uint8_t attr)
{
	// ESC [ Ps m
	xprintf(PSTR("\x1B[%dm"),attr);
}

void vt100SetCursorMode(uint8_t visible)
{
	if(visible)
		// ESC [ ? 25 h
		xprintf(PSTR("\x1B[?25h"));
	else
		// ESC [ ? 25 l
	xprintf(PSTR("\x1B[?25l"));
}

void vt100SetCursorPos(uint8_t line, uint8_t col)
{
	// ESC [ Pl ; Pc H
	xprintf(PSTR("\x1B[%d;%dH"),line,col);
}

